Attribute VB_Name = "DynamicDLL"
Option Explicit

Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

Public Declare Function TestString Lib "PeekMemory" () As Long
Public Declare Function SysAllocStringByteLen Lib "oleaut32" (ByVal lpString As Long, ByVal lLen As Long) As String
Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long

Declare Function GlobalAlloc Lib "kernel32" (ByVal Flags As Long, _
    ByVal Size As Long) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal Mem As Long) As Long

Declare Function EnumObjects Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal ObjectType As Long, _
    ByVal pEnumProc As Long, _
    ByVal lParam As Long) As Long

Declare Function MoveMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    ByRef Dest As Any, ByRef Src As Any, ByVal Size As Long) As Long

Public Const GMEM_FIXED As Long = 0
Public Const OBJ_PEN As Long = 1

Public Sub AddByte(ByRef PC As Long, ByVal ByteValue As Byte)
    MoveMemory ByVal PC, ByteValue, 1
    PC = PC + 1
End Sub

Public Sub AddInt(ByRef PC As Long, ByVal IntValue As Integer)
    MoveMemory ByVal PC, IntValue, 2
    PC = PC + 2
End Sub

Public Sub AddLong(ByRef PC As Long, ByVal LongValue As Long)
    MoveMemory ByVal PC, LongValue, 4
    PC = PC + 4
End Sub

Public Function CallFuncPtr(hDC As Long, FuncPtr As Long, ParamArray Params() As Variant) As Long

    Const MAX_CODESIZE As Long = 65536

    Dim i As Long
    Dim pCodeData As Long
    Dim pParamData() As Long
    Dim PC As Long
    Dim Operand As Long
    Dim RetValue As Long
    Dim StrValue As String
    Dim LongValue As Long
    
    ReDim pParamData(UBound(Params)) As Long
    pCodeData = GlobalAlloc(GMEM_FIXED, MAX_CODESIZE)
    PC = pCodeData
   
    AddByte PC, &H55
    
    For i = UBound(Params) To 0 Step -1
        If VarType(Params(i)) = vbString Then
            pParamData(i) = GlobalAlloc(GMEM_FIXED, LenB(Params(i)))
            StrValue = Params(i)
            MoveMemory ByVal pParamData(i), ByVal StrValue, LenB(StrValue)

            Operand = pParamData(i)
        Else
            Operand = Params(i)
        End If
             
        AddByte PC, &H68
        AddLong PC, Operand
    Next

    AddByte PC, &HB8
    AddLong PC, FuncPtr
    AddInt PC, &HD0FF
    
    AddByte PC, &HBA
    AddLong PC, VarPtr(RetValue)
    
    AddInt PC, &H289
    AddByte PC, &H5D
    AddInt PC, &HC033
    AddByte PC, &HC2
    AddInt PC, &H8

    EnumObjects hDC, OBJ_PEN, pCodeData, 0

    GlobalFree pCodeData
    For i = 0 To UBound(Params)
        If pParamData(i) <> 0 Then GlobalFree pParamData(i)
    Next

    CallFuncPtr = RetValue

End Function

'Convert a string pointer to a VB string
Public Function PtrToVBString(ByVal lPointer As Long) As String
    PtrToVBString = SysAllocStringByteLen(lPointer, lstrlen(lPointer))
End Function


