VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "JukePlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type PluginInfoType
    Name As String
    Author As String
    Version As String
End Type

Private pDC As Long
Private hDll As Long

Private pAddQueue As Long
Private pQueueClear As Long
Private pSongSuggestion As Long

Private pSongStart As Long
Private pSongEnd As Long
Private pSongPlayed As Long
Private pSongStatus As Long

Private pGetPluginInfo As Long
Private pVolume As Long
Private pInitialize As Long
Private pShutdown As Long

Private pCommand As Long

Private pAddCoin As Long
Private pPaidCoin As Long

Private PluginInfo As PluginInfoType

Public Sub Initialize(hDC As Long, PluginName As String)
    pDC = hDC
    hDll = LoadLibrary(PluginName)
       
    pGetPluginInfo = GetProcAddress(hDll, "Juke_GetPluginInfo")
    
    If IsPlugin Then
        pAddQueue = GetProcAddress(hDll, "Juke_AddQueue")
        pQueueClear = GetProcAddress(hDll, "Juke_QueueClear")
        pSongSuggestion = GetProcAddress(hDll, "Juke_SongSuggestion")

        pSongStart = GetProcAddress(hDll, "Juke_SongStart")
        pSongEnd = GetProcAddress(hDll, "Juke_SongEnd")
        pSongPlayed = GetProcAddress(hDll, "Juke_SongPlayed")
        pSongStatus = GetProcAddress(hDll, "Juke_SongStatus")

        pVolume = GetProcAddress(hDll, "Juke_Volume")
        pInitialize = GetProcAddress(hDll, "Juke_Initialize")
        pShutdown = GetProcAddress(hDll, "Juke_Shutdown")

        pCommand = GetProcAddress(hDll, "Juke_Command")

        pAddCoin = GetProcAddress(hDll, "Juke_AddCoin")
        pPaidCoin = GetProcAddress(hDll, "Juke_PaidCoin")
        
        If pGetPluginInfo <> 0 Then
            Dim sPluginInfo As String
            Dim sArray() As String
            
            sPluginInfo = PtrToVBString(CallFuncPtr(pDC, pGetPluginInfo, vbNull))
                       
            sArray = Split(sPluginInfo, ",")
        
            If UBound(sArray) + 1 = 3 Then
                PluginInfo.Name = sArray(0)
                PluginInfo.Author = sArray(1)
                PluginInfo.Version = sArray(2)
            End If
        End If
        
        If pInitialize <> 0 Then
            CallFuncPtr pDC, pInitialize, vbNull
        End If
    Else
        Shutdown
    End If
End Sub

Public Sub Shutdown()
    If pShutdown <> 0 Then
        CallFuncPtr pDC, pShutdown, vbNull
    End If
    FreeLibrary hDll
End Sub

' QUEUE FUNCTIONS

Public Sub AddQueue(File As String, SongTime As Long, Auto As Long, CoverArt As String, Title As String, Artist As String, Album As String, Genre As String, Special As String)
    If pAddQueue <> 0 Then
        CallFuncPtr pDC, pAddQueue, File + Chr(0), SongTime, Auto, CoverArt + Chr(0), Title + Chr(0), Artist + Chr(0), Album + Chr(0), Genre + Chr(0), Special + Chr(0)
    End If
End Sub

Public Sub QueueClear(ReSubmit As Long)
    If pQueueClear <> 0 Then
        CallFuncPtr pDC, pQueueClear, ReSubmit
    End If
End Sub

Public Sub SongSuggestion(File As String)
    If pSongSuggestion <> 0 Then
        CallFuncPtr pDC, pSongSuggestion, File + Chr(0)
    End If
End Sub

' STATUS FUNCTIONS

Public Sub SongStart()
    If pSongStart <> 0 Then
        CallFuncPtr pDC, pSongStart, vbNull
    End If
End Sub

Public Sub SongEnd(Skipped As Long)
    If pSongEnd <> 0 Then
        CallFuncPtr pDC, pSongEnd, Skipped
    End If
End Sub

Public Sub SongPlayed(Seconds As Long)
    If pSongPlayed <> 0 Then
        CallFuncPtr pDC, pSongPlayed, Seconds
    End If
End Sub

Public Sub SongStatus(Status As Long)
    If pSongStatus <> 0 Then
        CallFuncPtr pDC, pSongStatus, Status
    End If
End Sub

' APPLICATION INFO

Public Sub Volume(Value As Long)
    If pVolume <> 0 Then
        CallFuncPtr pDC, pVolume, Value
    End If
End Sub

' COMMANDS (Eg Play, Skip, VolumeUp VolumeDown, Lock, UnLock)

Public Sub Command(Name As String, Value As String)
    If pCommand <> 0 Then
        CallFuncPtr pDC, pCommand, Name, Value
    End If
End Sub

' CREDIT FUNCTIONS

Public Sub AddCoin(Coins As Long)
    If pCommand <> 0 Then
        CallFuncPtr pDC, pAddCoin, Coins
    End If
End Sub

Public Sub PaidCoin(Coins As Long)
    If pCommand <> 0 Then
        CallFuncPtr pDC, pPaidCoin, Coins
    End If
End Sub

Public Property Get IsPlugin() As Boolean
    IsPlugin = (pGetPluginInfo <> 0)
End Property

Public Property Get Name() As String
   Name = PluginInfo.Name
End Property

Public Property Get Author() As String
   Author = PluginInfo.Author
End Property

Public Property Get Version() As String
   Version = PluginInfo.Version
End Property

