// JukePlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

// standard windows headers
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <ole2.h>

#include "JukePlugin.h"

char m_buffer[4096];

#define PLUGIN_NAME		"Test Plugin"
#define PLUGIN_AUTHOR	"Ben Baker"
#define PLUGIN_VERSION	"1.0"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

// QUEUE FUNCTIONS

JUKEPLUGIN_API int __stdcall Juke_AddQueue(PCHAR File, int SongTime, int Auto, PCHAR CoverArt, PCHAR Title, PCHAR Artist, PCHAR Album, PCHAR Genre, PCHAR Special)
{
	char buf[8192];

	sprintf(buf, "File: %s, SongTime: %d Auto: %d, CoverArt: %s, Title: %s, Artist: %s, Album: %s, Genre: %s, Special: %s", File, SongTime, Auto, CoverArt, Title, Artist, Album, Genre, Special);

	MessageBox(NULL, buf, "Juke_AddQueue", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_QueueClear(int ReSubmit)
{
	char buf[8192];

	sprintf(buf, "ReSubmit: %d", ReSubmit);

	MessageBox(NULL, buf, "Juke_QueueClear", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_SongSuggestion(PCHAR File)
{
	char buf[8192];

	sprintf(buf, "File: %s", File);

	MessageBox(NULL, buf, "Juke_SongSuggestion", MB_OK);

	return 1;
}

// STATUS FUNCTIONS

JUKEPLUGIN_API int __stdcall Juke_SongStart(int Value)
{
	MessageBox(NULL, NULL, "Juke_SongStart", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_SongEnd(int Skipped)
{
	char buf[8192];

	sprintf(buf, "Skipped: %d", Skipped);

	MessageBox(NULL, buf, "Juke_SongEnd", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_SongPlayed(int Seconds)
{
	char buf[8192];

	sprintf(buf, "Seconds: %d", Seconds);

	MessageBox(NULL, buf, "Juke_SongPlayed", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_SongStatus(int Status)
{
	char buf[8192];

	sprintf(buf, "Status: %d", Status);

	MessageBox(NULL, buf, "Juke_SongStatus", MB_OK);

	return 1;
}

// APPLICATION INFO

JUKEPLUGIN_API PCHAR __stdcall Juke_GetPluginInfo(int Value)
{
	sprintf(m_buffer, "%s,%s,%s", PLUGIN_NAME, PLUGIN_AUTHOR, PLUGIN_VERSION);

	return m_buffer;
}

JUKEPLUGIN_API int __stdcall Juke_Volume(int Value)
{
	char buf[8192];

	sprintf(buf, "Value: %d", Value);

	MessageBox(NULL, buf, "Juke_Volume", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_Initialize(int Value)
{
	MessageBox(NULL, NULL, "Juke_Initialize", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_Shutdown(int Value)
{
	MessageBox(NULL, NULL, "Juke_Shutdown", MB_OK);

	return 1;
}

// COMMANDS (Eg Play, Skip, VolumeUp VolumeDown, Lock, UnLock)

JUKEPLUGIN_API int __stdcall Juke_Command(PCHAR Name, PCHAR Value)
{
	char buf[8192];

	sprintf(buf, "Name: %s, Value: %s", Name, Value);

	MessageBox(NULL, buf, "Juke_Command", MB_OK);

	return 1;
}

// CREDIT FUNCTIONS

JUKEPLUGIN_API int __stdcall Juke_AddCoin(int Coins)
{
	char buf[8192];

	sprintf(buf, "Coins: %d", Coins);

	MessageBox(NULL, buf, "Juke_AddCoin", MB_OK);

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_PaidCoin(int Coins)
{
	char buf[8192];

	sprintf(buf, "Coins: %d", Coins);

	MessageBox(NULL, buf, "Juke_PaidCoin", MB_OK);

	return 1;
}
